<template>
  <div class="audio-reader-bottom">
    <div  v-show="playingSong" class="post-song-ctn">
    <audio id="arb-player" controls="controls" @timeupdate="movePlayHead()">
  <source v-if="playingSong" :src="'http://localhost:3000/profile-posts/songs/'+playingSong.url" type="audio/mpeg" />
  </audio>
  <div class="arb-timeline" id="arb-timeline" v-on:click="dragPlayHead($event)">
    <div class="arb-bar-progress has-background-danger" id="arb-bar-progress"></div>
    <div class="arb-bar has-background-danger"></div>
      <div class="arb-playhead has-background-danger" id="arb-playhead"></div>
  </div>
    <div class="arb-ctn" v-if="playingSong">
      <div class="arb-ctn-left">
      <div class="arb-informations">
        <h3>{{playingSong.artist}}</h3>
        <h4>{{playingSong.name}}</h4>
      </div>
    </div>
    <div class="arb-center">
      <button class="has-background-danger" v-on:click="togglePlayingSong(playingSong)">
        <span class="icon" v-show="!isPlaying">
          <i class="fas fa-lg fa-play"></i>
        </span>
        <span class="icon" v-show="isPlaying">
          <i class="fas fa-lg fa-pause"></i>
        </span>
      </button>
    </div>
    <div class="arb-ctn-right">

    </div>
    </div>
  </div>
</div>
</template>
<script>
import { mapState, mapMutations, mapActions } from 'vuex'
export default {
  name: 'AudioReaderBottom',
  data(){
    return {

    }
  },
  computed:{
    ...mapState('profile',['playingSong']),
    isPlaying(){
      return this.playingSong?this.playingSong.isPlaying:undefined;
    }
  },
  methods: {
    ...mapMutations('profile',['setPlayingSong']),
    ...mapActions('profile',['togglePlayingSong']),
    movePlayHead() {
      var playMusic = (document.getElementById('arb-player'));
      var playHeadMusic = (document.getElementById('arb-playhead'));
      var timelineMusic = (document.getElementById("arb-timeline"));
      var barProgressMusic = (document.getElementById("arb-bar-progress"));
      var timelineWidth = timelineMusic.offsetWidth - playHeadMusic.offsetWidth;
      var playPercent = timelineWidth * (playMusic.currentTime / playMusic.duration);
      playHeadMusic.style.marginLeft = playPercent + "px";
      barProgressMusic.style.width = playPercent + "px";
      if (playMusic.currentTime == playMusic.duration) {
        this.isPlaying = false;
      }
    },
    dragPlayHead(event) {
      var playMusic = (document.getElementById('arb-player'));
      var playHeadMusic = (document.getElementById('arb-playhead'));
      var timelineMusic = (document.getElementById("arb-timeline"));
      var MousePositionX = event.clientX;
      var timelinePositionX = timelineMusic.getBoundingClientRect().left;
      var newTimelineMargLeft = MousePositionX - timelinePositionX;
      var timelineWidth = timelineMusic.offsetWidth - playHeadMusic.offsetWidth;
      if (newTimelineMargLeft >= 0 && newTimelineMargLeft <= timelineWidth) {
        playHeadMusic.style.marginLeft = newTimelineMargLeft + "px";
      }
      if (newTimelineMargLeft < 0) {
        playHeadMusic.style.marginLeft = "0px";
      }
      if (newTimelineMargLeft > timelineWidth) {
        playHeadMusic.style.marginLeft = timelineWidth + "px";
      }
      playMusic.currentTime = playMusic.duration * ((MousePositionX - timelinePositionX) / timelineWidth);
    }
  }
}
</script>
<style lang="scss">
.audio-reader-bottom{
  width: 100%;
  position: fixed;
  left: 0;
  bottom: 0;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  margin: auto;
  background-color: #fff;

.post-song-ctn {
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: start;
  padding:20px 30px;
  margin:0;
  h1{
    font-size: 17px;
  }
  audio{
  display: none;
}

  .arb-timeline{
  	width: 100%;
  	height: 20px;
  	background-color: transparent;
    align-items: center;
    display: flex;
    position: absolute;
    top: -10px;
    left: 0;
  	border-radius: 15px;
  }

  .arb-playhead{
  	width: 14px;
    z-index: 999;
  	height: 14px;
  	border-radius: 50%;
    transition: all 0.3s ease;
  }

  .arb-bar, .arb-bar-progress {
    width: 100%;
    position: absolute;
    height: 3px;
    opacity: 0.1;
  }
  .arb-bar-progress{
    opacity: 1;
    width:0;
    transition: all 0.3s ease;
  }
}

.arb-ctn{
  display: flex;
  align-items: center;
  width: 100%;
}

.arb-ctn-left{
    display: flex;
    width: 25%;
    align-items: flex-start;
    .arb-informations{
      h3{
        font-size: 13px;
        font-weight: 500;
      }
      h4{
            font-size: 19px;
      }
        text-align: left;
    }


    }

  .arb-center{
    width: 50%;
    display: flex;
    align-items: center;
    justify-content: center;
    button {
    background-color: transparent;
    border: none;
    display: flex;
    align-items: center;
    justify-content: center;
    box-shadow: none;
    width: 50px;
    height: 50px;
    border-radius: 50px;
    cursor: pointer;
    &:focus {
      outline:none;
    }
      span {

        color: white;
      }
}
  }





.arb-ctn-right {
  width: 25%;
}



}
</style>
